require_relative 'dummy_catcher'
# Fake class to deal with delegation.
class DummyString < String
  nully :downcase!, to: DummyCatcher.new
  nully :chomp!, to: DummyCatcher.new
  nully :end_with?, to: DummyCatcher.new
  nully :empty?, to: DummyCatcher.new, delegate_on_false: true
  nully :capitalize!, to: :catch_cap
  nully :delete!, to: :catch_delete
  nully :swapcase!, to: proc {  '_nully_' }
  nully :lstrip!, to: 'unmodded string', skip_delegation_call: true
  nully :rstrip!, to: :normal_string, skip_delegation_call: true
  nully :gsub!, to: proc { 'No Changes' }, skip_delegation_call: true

  def catch_cap
    'Catching cap'
  end

  def catch_delete(str)
    "Cant delete #{str} from #{self}"
  end

  def normal_string
    'nothing changed'
  end
end
